Proxmox/setup/debian-install.sh

98 lines
2.5 KiB
Bash
Raw Normal View History

2022-04-25 16:23:00 +02:00
#!/usr/bin/env bash
2022-04-16 15:31:31 +02:00
YW=`echo "\033[33m"`
2022-02-23 12:54:17 +01:00
RD=`echo "\033[01;31m"`
BL=`echo "\033[36m"`
2022-04-15 20:39:21 +02:00
GN=`echo "\033[1;92m"`
2022-02-23 12:54:17 +01:00
CL=`echo "\033[m"`
2022-03-11 04:19:18 +01:00
RETRY_NUM=10
2022-02-23 12:54:17 +01:00
RETRY_EVERY=3
NUM=$RETRY_NUM
2022-04-16 15:31:31 +02:00
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
2022-04-16 16:12:49 +02:00
HOLD="-"
2022-04-25 16:23:00 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
Correct Spelling (#360) * Update adguard-install.sh * Update daemonsync-install.sh * Update dashy-install.sh * Update debian-install.sh * Update deconz-install.sh * Update docker-install.sh * Update esphome-install.sh * Update grafana-install.sh * Update heimdalldashboard-install.sh * Update homeassistant-install.sh * Update homebridge-install.sh * Update influxdb-install.sh * Update iobroker-install.sh * Update jellyfin-install.sh * Update keycloak-install.sh * Update magicmirror-install.sh * Update mariadb-install.sh * Update meshcentral-install.sh * Update motioneye-install.sh * Update mqtt-install.sh * Update nginx-proxy-manager-install.sh * Update nocodb-install.sh * Update node-red-install.sh * Update omada-install.sh * Update openhab-install.sh * Update photoprism-install.sh * Update pihole-install.sh * Update plex-install.sh * Update podman-homeassistant-install.sh * Update postgresql-install.sh * Update prometheus-install.sh * Update technitiumdns-install.sh * Update ubuntu-install.sh * Update unifi-install.sh * Update uptimekuma-install.sh * Update vaultwarden-install.sh * Update whoogle-install.sh * Update wireguard-install.sh * Update zigbee2mqtt-install.sh * Update zwavejs2mqtt-install.sh * Update adguard-v3.sh * Update create_lxc.sh * Update daemonsync-v3.sh * Update dashy-v3.sh * Update debian-v3.sh * Update deconz-v3.sh * Update docker-v3.sh * Update esphome-v3.sh * Update grafana-v3.sh * Update heimdalldashboard-v3.sh * Update homeassistant-v3.sh * Update homebridge-v3.sh * Update influxdb-v3.sh * Update iobroker-v3.sh * Update jellyfin-v3.sh * Update keycloak-v3.sh * Update magicmirror-v3.sh * Update mariadb-v3.sh * Update meshcentral-v3.sh * Update motioneye-v3.sh * Update mqtt-v3.sh * Update nginx-proxy-manager-v3.sh * Update nocodb-v3.sh * Update node-red-v3.sh * Update omada-v3.sh * Update openhab-v3.sh * Update photoprism-v3.sh * Update pihole-v3.sh * Update plex-v3.sh * Update podman-homeassistant-v3.sh * Update postgresql-v3.sh * Update prometheus-v3.sh * Update technitiumdns-v3.sh * Update ubuntu-v3.sh * Update unifi-v3.sh * Update uptimekuma-v3.sh * Update vaultwarden-v3.sh * Update whoogle-v3.sh * Update wireguard-v3.sh * Update zigbee2mqtt-v3.sh * Update zwavejs2mqtt-v3.sh
2022-07-20 12:10:39 +02:00
local reason="Unknown failure occurred."
2022-04-25 16:23:00 +02:00
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-16 15:31:31 +02:00
2022-04-16 16:02:12 +02:00
function msg_info() {
2022-04-16 15:31:31 +02:00
local msg="$1"
2022-04-16 15:36:09 +02:00
echo -ne " ${HOLD} ${YW}${msg}..."
2022-04-16 15:31:31 +02:00
}
2022-04-16 16:02:12 +02:00
function msg_ok() {
2022-04-16 15:31:31 +02:00
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
}
2022-08-30 02:22:03 +02:00
function msg_error() {
local msg="$1"
echo -e "${BFR} ${CROSS} ${RD}${msg}${CL}"
}
2022-02-23 12:54:17 +01:00
2022-04-16 15:31:31 +02:00
msg_info "Setting up Container OS "
2022-02-23 12:54:17 +01:00
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
2022-05-05 11:56:57 +02:00
1>&2 echo -en "${CROSS}${RD} No Network! "
2022-02-23 12:54:17 +01:00
sleep $RETRY_EVERY
((NUM--))
if [ $NUM -eq 0 ]
then
2022-04-23 18:13:52 +02:00
1>&2 echo -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
2022-02-23 12:54:17 +01:00
exit 1
fi
done
2022-04-16 17:42:32 +02:00
msg_ok "Set up Container OS"
2022-04-16 15:31:31 +02:00
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-02-23 12:54:17 +01:00
2022-08-30 21:37:13 +02:00
if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected"; IC="YES"; else msg_error "Internet NOT Connected"; IC="NO"; fi;
if [[ ${IC} == "YES" ]]; then RESOLVEDIP=$(nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
if [[ -z "$RESOLVEDIP" ]]; then msg_error "DNS Lookup Failure"; else msg_ok "DNS Resolved github.com to $RESOLVEDIP"; fi;
fi
2022-08-30 02:22:03 +02:00
2022-04-16 15:31:31 +02:00
msg_info "Updating Container OS"
2022-08-30 00:43:55 +02:00
apt-get update &>/dev/null
apt-get -y upgrade &>/dev/null
2022-04-16 17:42:32 +02:00
msg_ok "Updated Container OS"
2022-02-23 12:54:17 +01:00
2022-04-16 15:31:31 +02:00
msg_info "Installing Dependencies"
2022-02-23 12:54:17 +01:00
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
2022-04-16 17:42:32 +02:00
msg_ok "Installed Dependencies"
2022-02-23 12:54:17 +01:00
2022-03-08 15:30:26 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6);
if [[ $PASS != $ ]]; then
2022-04-16 15:31:31 +02:00
msg_info "Customizing Container"
2022-04-22 20:59:37 +02:00
chmod -x /etc/update-motd.d/*
2022-02-23 12:54:17 +01:00
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat << EOF > $GETTY_OVERRIDE
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
2022-04-16 17:42:32 +02:00
msg_ok "Customized Container"
2022-03-08 15:30:26 +01:00
fi
2022-04-16 17:42:32 +02:00
msg_info "Cleaning up"
2022-02-23 12:54:17 +01:00
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
rm -rf /var/{cache,log}/* /var/lib/apt/lists/*
2022-04-16 17:42:32 +02:00
msg_ok "Cleaned"